--- wcsmbs/wcpncpy.c	1 Jun 2003 07:06:26 -0000	1.4
+++ wcsmbs/wcpncpy.c	22 Jul 2003 19:19:55 -0000	1.5
@@ -31,8 +31,6 @@
   wint_t c;
   wchar_t *const s = dest;
 
-  --dest;
-
   if (n >= 4)
     {
       size_t n4 = n >> 2;
@@ -40,19 +38,19 @@
       for (;;)
 	{
 	  c = *src++;
-	  *++dest = c;
+	  *dest++ = c;
 	  if (c == L'\0')
 	    break;
 	  c = *src++;
-	  *++dest = c;
+	  *dest++ = c;
 	  if (c == L'\0')
 	    break;
 	  c = *src++;
-	  *++dest = c;
+	  *dest++ = c;
 	  if (c == L'\0')
 	    break;
 	  c = *src++;
-	  *++dest = c;
+	  *dest++ = c;
 	  if (c == L'\0')
 	    break;
 	  if (--n4 == 0)
--- /dev/null	2003-01-13 18:16:28.000000000 +0900
+++ wcsmbs/tst-wcpncpy.c	2003-07-23 04:23:43.000000000 +0900
@@ -0,0 +1,31 @@
+/* Copyright (C) 2003 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+   Contributed by Ulrich Drepper <drepper@cygnus.com>, 2003.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, write to the Free
+   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
+   02111-1307 USA.  */
+
+#include <wchar.h>
+
+
+int
+main (void)
+{
+  const wchar_t src[] = L"0";
+  wchar_t dest[10];
+  wmemset (dest, L'\0', 10);
+  wcpncpy (dest, src, 2);
+  return wcscmp (dest, src) != 0;
+}
--- wcsmbs/Makefile	29 Aug 2002 06:37:43 -0000	1.20
+++ wcsmbs/Makefile	22 Jul 2003 19:23:54 -0000	1.21
@@ -1,4 +1,4 @@
-# Copyright (C) 1995-2000, 2002 Free Software Foundation, Inc.
+# Copyright (C) 1995-2000, 2002, 2003 Free Software Foundation, Inc.
 # This file is part of the GNU C Library.
 
 # The GNU C Library is free software; you can redistribute it and/or
@@ -40,7 +40,7 @@
 	    wcsmbsload mbsrtowcs_l
 
 tests := tst-wcstof wcsmbs-tst1 tst-wcsnlen tst-btowc tst-mbrtowc \
-	 tst-wcrtomb
+	 tst-wcrtomb tst-wcpncpy
 
 include ../Rules
 
